// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from nao_command_msgs:msg/JointStiffnesses.idl
// generated code does not contain a copyright notice

#include "nao_command_msgs/msg/detail/joint_stiffnesses__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_type_hash_t *
nao_command_msgs__msg__JointStiffnesses__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x53, 0xee, 0x70, 0x0c, 0x2b, 0xaa, 0xe9, 0x13,
      0x89, 0x25, 0xd5, 0x92, 0xfc, 0x8f, 0x87, 0xed,
      0x88, 0x2d, 0xed, 0x15, 0x81, 0xd2, 0x45, 0xd4,
      0x53, 0x64, 0x20, 0x2b, 0xe3, 0x2b, 0x5c, 0x0b,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char nao_command_msgs__msg__JointStiffnesses__TYPE_NAME[] = "nao_command_msgs/msg/JointStiffnesses";

// Define type names, field names, and default values
static char nao_command_msgs__msg__JointStiffnesses__FIELD_NAME__indexes[] = "indexes";
static char nao_command_msgs__msg__JointStiffnesses__FIELD_NAME__stiffnesses[] = "stiffnesses";

static rosidl_runtime_c__type_description__Field nao_command_msgs__msg__JointStiffnesses__FIELDS[] = {
  {
    {nao_command_msgs__msg__JointStiffnesses__FIELD_NAME__indexes, 7, 7},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {nao_command_msgs__msg__JointStiffnesses__FIELD_NAME__stiffnesses, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
nao_command_msgs__msg__JointStiffnesses__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {nao_command_msgs__msg__JointStiffnesses__TYPE_NAME, 37, 37},
      {nao_command_msgs__msg__JointStiffnesses__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Message to specify stiffnesses for the NAO's motor joints.\n"
  "#\n"
  "# Each joint is uniquely identified by its index (See JointIndexes.msg)\n"
  "#\n"
  "# The two arrays in this message should have the same size, where the first item\n"
  "# in indexes, corresponds to the first item in stiffnesses, etc.\n"
  "\n"
  "uint8[] indexes  # See JointIndexes.msg (eg. JointIndexes::HEADYAW)\n"
  "float32[] stiffnesses  # 0.0 - 1.0";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
nao_command_msgs__msg__JointStiffnesses__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {nao_command_msgs__msg__JointStiffnesses__TYPE_NAME, 37, 37},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 386, 386},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
nao_command_msgs__msg__JointStiffnesses__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *nao_command_msgs__msg__JointStiffnesses__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
