// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_command_msgs:msg/RightEyeLeds.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "nao_command_msgs/msg/right_eye_leds.hpp"


#ifndef NAO_COMMAND_MSGS__MSG__DETAIL__RIGHT_EYE_LEDS__STRUCT_HPP_
#define NAO_COMMAND_MSGS__MSG__DETAIL__RIGHT_EYE_LEDS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'colors'
#include "std_msgs/msg/detail/color_rgba__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__nao_command_msgs__msg__RightEyeLeds __attribute__((deprecated))
#else
# define DEPRECATED__nao_command_msgs__msg__RightEyeLeds __declspec(deprecated)
#endif

namespace nao_command_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RightEyeLeds_
{
  using Type = RightEyeLeds_<ContainerAllocator>;

  explicit RightEyeLeds_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->colors.fill(std_msgs::msg::ColorRGBA_<ContainerAllocator>{_init});
    }
  }

  explicit RightEyeLeds_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : colors(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->colors.fill(std_msgs::msg::ColorRGBA_<ContainerAllocator>{_alloc, _init});
    }
  }

  // field types and members
  using _colors_type =
    std::array<std_msgs::msg::ColorRGBA_<ContainerAllocator>, 8>;
  _colors_type colors;

  // setters for named parameter idiom
  Type & set__colors(
    const std::array<std_msgs::msg::ColorRGBA_<ContainerAllocator>, 8> & _arg)
  {
    this->colors = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t R0 =
    0;
  static constexpr int32_t R1 =
    1;
  static constexpr int32_t R2 =
    2;
  static constexpr int32_t R3 =
    3;
  static constexpr int32_t R4 =
    4;
  static constexpr int32_t R5 =
    5;
  static constexpr int32_t R6 =
    6;
  static constexpr int32_t R7 =
    7;
  static constexpr int32_t NUM_LEDS =
    8;

  // pointer types
  using RawPtr =
    nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_command_msgs__msg__RightEyeLeds
    std::shared_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_command_msgs__msg__RightEyeLeds
    std::shared_ptr<nao_command_msgs::msg::RightEyeLeds_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RightEyeLeds_ & other) const
  {
    if (this->colors != other.colors) {
      return false;
    }
    return true;
  }
  bool operator!=(const RightEyeLeds_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RightEyeLeds_

// alias to use template instance with default allocator
using RightEyeLeds =
  nao_command_msgs::msg::RightEyeLeds_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R0;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R6;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::R7;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RightEyeLeds_<ContainerAllocator>::NUM_LEDS;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace nao_command_msgs

#endif  // NAO_COMMAND_MSGS__MSG__DETAIL__RIGHT_EYE_LEDS__STRUCT_HPP_
